io.undertow.predicate

## Class PredicateParser

- java.lang.Object
- - io.undertow.predicate.PredicateParser

    public class PredicateParser
    extends Object

Parser that can build a predicate from a string representation. The underlying syntax is quite simple, and example is shown below:

`path["/MyPath"] or (method[value="POST"] and not headersPresent[value={Content-Type, "Content-Encoding"}, ignoreTrailer=true]`

The following boolean operators are built in, listed in order or precedence: - not - and - or

They work pretty much as you would expect them to. All other tokens are taken to be predicate names. If the predicate does not require any parameters then the brackets can be omitted, otherwise they are mandatory.

If a predicate is only being passed a single parameter then the parameter name can be omitted. Strings can be enclosed in optional double or single quotations marks, and quotation marks can be escaped using `\"`.

Array types are represented via a comma separated list of values enclosed in curly braces.

TODO: should we use antlr (or whatever) here? I don't really want an extra dependency just for this...

Author:
  Stuart Douglas

### Constructor Summary

Constructors
Constructor and Description
`PredicateParser()`

### Method Summary

All Methods Static Methods Concrete Methods
`static Predicate` `parse(String string, ClassLoader classLoader)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### PredicateParser

    public PredicateParser()

### Method Detail

#### parse

    public static final Predicate parse(String string,
                                        ClassLoader classLoader)